@/data/kbah/code/FGF/bradcompfiles/code/compfiles/sub_pro/READ_ABI_NETCDF_01.PRO
@/data/kbah/code/FGF/bradcompfiles/code/compfiles/sub_pro/colorbar.pro

PRO COMPARE_TWO_FILES
a_sub='2100utc/'

f1_pre='/data/kbah/code/FGF/bradcompfiles/input/grb/'+a_sub  ;/media/MyBook/output/katrina/GRB_scaled/'+ a_sub    
f2_pre='/data/kbah/code/FGF/bradcompfiles/input/val/'+ a_sub
 sub_1='*.nc'   & sub_2= '*.nc'

 grb_files = FIlE_SEARCH(f1_pre, sub_1)
 val_files = FIlE_SEARCH(f2_pre, sub_2)

IF (N_ELEMENTS(grb_files) NE N_ELEMENTS(val_files)) THEN  MESSAGE, 'THE NUMBER OF GRB FILES IS NOT EQUAL TO THAT OF VAL. FILES'
FOR i=1,   N_ELEMENTS(grb_files) DO BEGIN
    grb=READ_ABI_NETCDF_01(grb_files(i-1)) ;;GRB FILE
    val=READ_ABI_NETCDF_01(val_files(i-1))
    
    glat= '0' ;grb.dataset(0).data    &
    glon='0'  ; grb.dataset(1).data
    vlat='0' ;val.dataset(2).data    &
    vlon='0' ; val.dataset(1).data
    
   ; IF (i LE 5 OR i NE 4) THEN BEGIN
     ;
          goffset=DOUBLE(grb.dataset(0).attrval(2))  & gscale=DOUBLE(grb.dataset(0).attrval(3))
          grefl=(grb.dataset(0).data(*,*)* gscale) +goffset
          vrefl=val.dataset(0).data
;            ;;test lat lon       ;;;;;;;;
;             grefl=grb.dataset(0).data(*,*)
;             vrefl=val.dataset(0).data
             refl_diff=grefl-vrefl
             grad=TEMPORARY(grefl) & vrad=TEMPORARY(vrefl) & rad_diff=TEMPORARY(refl_diff)
   ; ENDIF ELSE BEGIN
   ;       
   ;        goffset1=DOUBLE(grb.dataset(0).attrval(2))  & gscale1=DOUBLE(grb.dataset(0).attrval(4))
   ;        goffset2=DOUBLE(grb.dataset(0).attrval(2))  & gscale2=DOUBLE(grb.dataset(0).attrval(4))
   ;         
   ;        grad=(grb.dataset(0).data(*,*)* gscale1) +goffset1
   ;        gtbb=(grb.dataset(0).data(*,*)* gscale2) +goffset2
            
   ;        vrad=val.dataset(0).data 
   ;        vtbb=val.dataset(0).data
           
   ;        tbb_diff= gtbb - vtbb
   ;        rad_diff= grad - vrad
           
   ;        grad=gtbb & vrad=vtbb & rad_diff=tbb_diff
                
  ;  ENDELSE
    
    sss='band'+STRTRIM(STRING(i),1)
    IF (i LT 10) THEN sss='band0'+STRTRIM(STRING(i),1)
    output='/data/kbah/code/FGF/bradcompfiles/output/'+ a_sub +sss+'.png'   ;+STRING(i)+ 'test.png'  ;STRING(i)+ 
    print_multi, grad, vrad, rad_diff, vlat, vlon, i,output
    PRINT, 'STOP'
ENDFOR
 
 
 
 
;;;;;;;Printing images;




END



PRO print_multi, grad, vrad,rad_diff, vlat, vlon, i, output


 !P.MULTI=[0,2,2,0,0]
 
 ; Save device settings and tell IDL to use a color table
 DEVICE, GET_DECOMPOSED=old_decomposed
 DEVICE, DECOMPOSED=0
 LOADCT, 39
 
 ; Create an image and display it
 IMAGE1=TEMPORARY(grad)
 IMAGE2=TEMPORARY(vrad)
 IMAGE3 =TEMPORARY(rad_diff)  ; DIST(300)

;Set the image size, window size, and image location coordinates
xsize=1100          &     ysize=750
WINDOW, 1  , xsize=xsize, ysize=ysize
  
xsize_window = FIX(xsize);*0.50)
ysize_window = FIX(ysize);*0.50)  ;1.05)
xstart_img = 0
ystart_img = 0
  
pos = fltarr(4)
pos[0] = xstart_img / float(xsize_window)
pos[1] = ystart_img / float(ysize_window)   ;+ 0.10
pos[2] = (xstart_img + xsize) / float(xsize_window) ;-0.5
pos[3] = (ystart_img + ysize) / float(ysize_window) ;-0.5

;aa=WHERE(vlat GT -90)  & BB=where(vlon GT -180)

 
g_lat=where(vlat GE -90 AND vlat LE 90)
g_lon=where(vlon GE -180 AND vlon LE 180)

latmin=MIN(vlat(g_lat), MAX=latmax)   &   lonmin=MIN(vlon(g_lon), MAX=lonmax)
limit=[-90,160, 90, 320]  ;[-80, -150.0, 80.0, -80.0] ;[-10.0,180.0,  58.0,105.0]  ;[latmin,lonmin,latmax,lonmax]

lat0=0 ;142   ;MEDIAN(vlat(g_lat)) ;38
lon0=240  ;MEDIAN(vlon(g_lon)) ;-95

latmin=limit[0] & latmax=limit[2]  &   lonmin=limit[1] &  lonmax=limit[3]

pos[0]=POS[0] &  pos[1]=POS[1]+ 0.5 & pos[2]=0.5   &  pos[3]=0.98
map_set,lat0,lon0,0, /noerase,limit=limit,/cylindrical, position=pos
;img1_map = MAP_IMAGE(IMAGE1, Startx, Starty, COMPRESS=1, latmin=latmin, lonmin=lonmin, latmax=latmax, lonmax=lonmax)  
;TVSCL, img1_map, Startx, Starty
TVSCL, MAP_IMAGE(IMAGE1, Startx, Starty, COMPRESS=1, latmin=latmin, lonmin=lonmin, latmax=latmax, lonmax=lonmax), Startx, Starty
 ;MAP_CONTINENTS, /continents   ;, /USA, color=0  ;
 
 
pos[0]=pos[0]+0.5 &  pos[1]=pos[1] & pos[2]=pos[2]+0.5   &  pos[3]=pos[3]
map_set,lat0,lon0,0, /noerase,limit=limit,/cylindrical, position=pos
;img2_map = MAP_IMAGE(IMAGE2, Startx, Starty, COMPRESS=1, latmin=latmin, lonmin=lonmin, latmax=latmax, lonmax=lonmax)  
;TVSCL, img2_map, Startx, Starty

TVSCL, MAP_IMAGE(IMAGE2, Startx, Starty, COMPRESS=1, latmin=latmin, lonmin=lonmin, latmax=latmax, lonmax=lonmax) , Startx, Starty
;MAP_CONTINENTS, /continents ; , /USA, color=0 ;
  
 
pos[0]=0 &  pos[1]=0 & pos[2]=0.50   &  pos[3]=0.5
map_set,lat0,lon0,0, /noerase,limit=limit,/cylindrical, position=pos
;img3_map = MAP_IMAGE(IMAGE3, Startx, Starty, latmin=latmin, lonmin=lonmin, latmax=latmax, lonmax=lonmax) ; COMPRESS=4,
;TVSCL, img3_map, Startx, Starty
TVSCL,  MAP_IMAGE(IMAGE3, Startx, Starty, latmin=latmin, lonmin=lonmin, latmax=latmax, lonmax=lonmax), Startx, Starty
; MAP_CONTINENTS, /continents   ;, /USA, color=1 ;
 
                   
;;;Make a histogram of the difference
   ;img3_map=IMAGE3
   rr=IMAGE3    ;(WHERE(img3_map GT -500))
   ss=HISTOGRAM(rr, MIN=MIN(rr), MAX=MAX(rr), BINSIZE=(max(rr)-min(rr))/100.0) ; HISTOGRAM(img3_map, BINSIZE=0.00000001)
    
;    tot_incr=size(ss, /DIMENSION) & tot_pts=CEIL(ABS(MIN(ss)) +ABS(max(ss)))
;    divisor= FLOAT(FLOAT(tot_incr)/FLOAT(tot_pts))
    x = min(rr) + (max(rr)-min(rr))*FINDGEN(n_elements(ss))/(1.0*N_ELEMENTS(ss)-1)  ;FINDGEN(tot_incr) ;(tot_incr)/divisor)  ;+ 0.001; + MIN(ss)  

  pos[0]=0.55 &  pos[1]=0.045 & pos[2]=0.99   &  pos[3]=0.48
  PLOT,  x,ss , /noerase, position=pos, ytitle='Difference', xtitle='Absolute diff.'  


;;;Do simple stats
min_diff=MIN(IMAGE3 ) & max_diff=MAX(IMAGE3 )
stats=MOMENT(IMAGE3 , MDEV=mean_abs, SDEV=std_dev)
;x=IMAGE1  & y=IMAGE2 
;corr=TEMPORARY(CORRELATE(IMAGE1 ,IMAGE2 ))
d_size=SIZE(IMAGE3 , /dimensions)



XYOUTS, 615, 300,  'Minimum Diff:  '+ STRTRIM(STRING(min_diff),1), CHARSIZE=0.8, CHARTHICK=1.0,  /DEVICE
XYOUTS, 615, 280,  'Maximum Diff:  '+ STRTRIM(STRING(max_diff),1), CHARSIZE=0.8, CHARTHICK=1.0,  /DEVICE
;XYOUTS, 615, 260,  'Correlation Coeff.:  '+ STRTRIM(STRING(corr),1),CHARSIZE=0.8, CHARTHICK=1.0,  /DEVICE
XYOUTS, 615, 240,  'Mean Abs. dev:  ' + STRTRIM(STRING(mean_abs),1),CHARSIZE=0.8, CHARTHICK=1.0,  /DEVICE
XYOUTS, 615, 220,  'Std. dev:  '+ STRTRIM(STRING(std_dev),1),   CHARSIZE=0.8, CHARTHICK=1.0,  /DEVICE

XYOUTS, 615, 200,  'Mean diff:  '+ STRTRIM(STRING(stats[0]),1), CHARSIZE=0.8, CHARTHICK=1.0,  /DEVICE
XYOUTS, 615, 180,  'Variance:  '+ STRTRIM(STRING(stats[1]),1), CHARSIZE=0.8, CHARTHICK=1.0,   /DEVICE
;XYOUTS, 615, 160,  'Skewness:  '+ STRTRIM(STRING(stats[2]),1), CHARSIZE=1.0, CHARTHICK=1.0,   /DEVICE
;XYOUTS, 615, 140,  'Kurtosis:  '+ STRTRIM(STRING(stats[3]),1), CHARSIZE=1.0, CHARTHICK=1.0,  /DEVICE
XYOUTS, 615, 160,  'Data size:  '+ STRTRIM(STRING(d_size[0]),1)+' X '+ STRTRIM(STRING(d_size[1]),1), CHARSIZE=0.8, CHARTHICK=1.2,  /DEVICE

;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;; IMAGE Labels    ;;;;;;;;
XYOUTS, 120, 690,  'GRB FILE (DATA: "SCALED INTEGER")', CHARSIZE=1.2, CHARTHICK=2.8, /DEVICE
XYOUTS, 670, 690,  'VALIDATION FILE (DATA: "FLOAT")', CHARSIZE=1.2, CHARTHICK=2.8, /DEVICE
XYOUTS, 120, 330,  'GRB-VAL. DIFFERENCE IMAGE ', CHARSIZE=1.2, CHARTHICK=2.8, color=2, /DEVICE
XYOUTS, 670, 330,  'HISTOGRAM OF DIFFERENCE', CHARSIZE=1.2, CHARTHICK=2.8, /DEVICE



 ;;;;;;;;;;; ADD COLORBAR    ;;;;;;;;;;
 
 c_min=min(IMAGE1) & c_max=max(IMAGE1)
 IF (min(IMAGE2) LT min(IMAGE1)) THEN c_min=min(IMAGE2)
 IF (max(IMAGE2) GT max(IMAGE1)) THEN c_max=max(IMAGE2)
  
 c_min=min(IMAGE1) & c_max=max(IMAGE1)
 
 COLORBAR,  VERTICAL=1, RANGE=[c_min, c_max], POSITION=[0.48, 0.52, 0.50, 0.97], FORMAT='(F9.5)'  
 COLORBAR,  VERTICAL=1, RANGE=[c_min, c_max], POSITION=[0.97, 0.52, 0.99, 0.97], FORMAT='(F9.5)'  
 COLORBAR,  VERTICAL=1, RANGE=[min(IMAGE3), max(IMAGE3)], POSITION=[0.48, 0.02, 0.50, 0.48], FORMAT='(E10.2)', COLOR=2
 
 
 ;;;band information  ;;;;;;;;;;;;
 band_n=['Band01(0.47)','Band02(0.64)','Band03(0.865)', 'Band04(1.378)','Band05(1.61)', 'Band06(2.25)', 'Band07(3.90)',  'Band08(6.19)', $
         'Band09(6.95)','Band10(7.34)', 'Band11(8.5)', 'Band12(9.61)', 'Band13(10.35)', 'Band14(11.2)', 'Band15(12.3)', 'Band16(13.3)']
         
;;;Quantization step information ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
q_steps=[0.00007325, 0.00029311, 0.00007325, 0.00007325 , 0.00007325, 0.00007325, 0.00152729, 0.00173056, $
         0.00279270, 0.00492614, 0.00830485, 0.00671469, 0.01130814,0.01226041, 0.01306617, 0.01064278]      
              
   aband=STRING(band_n(i-1)+'UM')
         
   XYOUTS, 720, 730,  aband, CHARSIZE=1.3, CHARTHICK=2.0, /DEVICE
   XYOUTS, 200, 730,  aband, CHARSIZE=1.3, CHARTHICK=2.0, /DEVICE
   XYOUTS, 615, 140,  '0.5*Quantization Step: '+ STRTRIM(STRING(q_steps(i-1)/2.0),1), CHARSIZE=0.8, CHARTHICK=1.0,  /DEVICE
 
 ; Write a PNG file to the temporary directory
 ; Note the use of the TRUE keyword to TVRD
 filename =output   ; FILEPATH('test.png', /TMP)
 WRITE_PNG, filename, TVRD(/TRUE)
 PRINT, 'File written to ', filename

; 
 ; Restore device settings.
 DEVICE, DECOMPOSED=old_decomposed

!P.MULTI=0
print, 'Done'

END