;;;;;;;;;;;******************************************************************************************
FUNCTION READ_ABI_NETCDF_01, inputfiles,katr, outputfile, dprint, xx=xx, yy=yy
	if not keyword_set(dprint ) then dprint = 0
	if not keyword_set( outputfile ) then outputfile=''
		

;;	west_east=2654 & south_north=1222 
         zz=N_ELEMENTS(inputfiles)  
;;	IF (katr EQ 1) THEN BEGIN
;;		west_east=753 
;;		south_north=685
;;	ENDIF

dname1='x' & dname2='y'
  
;if not keyword_set( xx ) then dname1='west_east' 
;if not keyword_set( yy ) then dname2='south_north'

	IF (inputfiles(0) NE '')THEN BEGIN
		
		ncdfid= NCDF_OPEN(inputfiles(0))
   		fileinfo= NCDF_INQUIRE(ncdfid)
                 
    WE = NCDF_DIMID( ncdfid, dname1) 
		SE = NCDF_DIMID( ncdfid, dname2)
		
		NCDF_DIMINQ, ncdfid, WE, Name1, Size1 
		NCDF_DIMINQ, ncdfid, SE, Name2, Size2
 
		ngatts=fileinfo.ngatts
    nvars=fileinfo.nvars
		gattrnames=STRARR(ngatts)
		
		gatts={name:'',value:''} 
		gats=REPLICATE(gatts,ngatts)

		varnames=STRARR(nvars)
		dataset={data:FLTARR(Size1, Size2),var:'', attr:STRARR(8), attrval:STRARR(8),nvars:nvars, nvarsatt:0, ngatts:ngatts}
		;dataset=REPLICATE(avarset, 1}  ;nvars)
		newoutdata= {gats:gats,dataset:dataset}
	  ;newoutdata=outdata ;REPLICATE(outdata, zz) ;nvars)

		NCDF_CLOSE, ncdfid
	;;ENDIF
	
	FOR ww=0, zz-1 DO BEGIN
	
		ncdfid= NCDF_OPEN(inputfiles(0))
   	fileinfo= NCDF_INQUIRE(ncdfid)

		ngatts=fileinfo.ngatts
    nvars=fileinfo.nvars
		gattrnames=STRARR(ngatts)
		


		 FOR i=0L, ngatts -1L DO BEGIN
			gattrnames[i]= NCDF_ATTNAME(ncdfid,i, /global)
				       NCDF_ATTGET,ncdfid, gattrnames[i], gattvalue, /global
				       gats(i).name=gattrnames[i]
				       gats(i).value=string(gattvalue)
				       IF (dprint EQ 1) THEN printf, 1, gats(i)
					;print, 'gats' ,gats(i)
		 ENDFOR
		
		FOR j=0L, nvars-1L DO BEGIN
		  ;FOR j=2, 2 DO BEGIN
		  IF (j EQ 0) THEN BEGIN
		        varinfo=NCDF_VARINQ(ncdfid,j)
            dataset(0).var=varinfo.name  
            IF (dprint EQ 1) THEN printf,1, dataset(0).var

		        varid=NCDF_VARID(ncdfid, varinfo.name)
            NCDF_VARGET,ncdfid, varid, temp_data
            dataset(0).data = temp_data
		     
            kkk= where (temp_data GE -997) & lll=SIZE(KKK)
            IF (j EQ 2) THEN print, 'Reding file: ', inputfiles(0)
            IF (lll(0) GT 0) THEN  PRINT, 'MIN:', MIN(temp_data(kkk)), ' MAX:', MAX(temp_data)
            IF (lll(0) LE 0) THEN begin
                PRINT, 'MIN:', MIN(temp_data), ' MAX:', MAX(temp_data)
             ENDIF 
		     
		        IF (dprint EQ 1) THEN printf,1 ,dataset(j).data

		          ;print, 'data-var ',dataset(j).var
              natts=varinfo.natts
              dataset.nvarsatt=natts
              FOR k=0L, natts- 1L DO BEGIN
                dataset(0).attr(k)=NCDF_ATTNAME(ncdfid,varid, k) 
                NCDF_ATTGET, ncdfid, varid, dataset(0).attr(k), attvalue
                IF ((j LE 1) AND  (k EQ 2) AND nvars  GE 3) THEN BEGIN
                    dataset(0).attrval(k)= string(attvalue(0))
                ENDIF ELSE BEGIN
                dataset(0).attrval(k)= string(attvalue)    ;;crashes when reading "-90, 90" or "-180 180"
                
                ;IF (dprint EQ 1) THEN printf, 1,'	',dataset(j).attr(k),':  ',string(attvalue)
                ;print ,' hello   ', dataset(j).attr(k) , ':  ',string(attvalue)
 
         ENDELSE
				
				ENDFOR	
		     ;	IF (j LT 2) THEN BEGIN
		
				newoutdata.gats=gats	
				
 				newoutdata.dataset(0)= dataset(0)
			
			ENDIF
			
		ENDFOR
		
		NCDF_CLOSE, ncdfid
		CLOSE, /ALL
	ENDFOR
	
 ENDIF ELSE BEGIN
    newoutdata=''
 ENDELSE
 
RETURN, newoutdata

END
;;;;***********************************************************************************************
